// EEPROMDlg.cpp : implementation file
//

#include "stdafx.h"
#include "EEPROM.h"
#include "EEPROMDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <time.h>

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEEPROMDlg dialog

CEEPROMDlg::CEEPROMDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEEPROMDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEEPROMDlg)
	m_port = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEEPROMDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEEPROMDlg)
	DDX_Text(pDX, IDC_EDIT1, m_port);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEEPROMDlg, CDialog)
	//{{AFX_MSG_MAP(CEEPROMDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnOpen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEEPROMDlg message handlers

BOOL CEEPROMDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_hFile == NULL;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CEEPROMDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEEPROMDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEEPROMDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CEEPROMDlg::OnOpen() 
{
	// TODO: Add your control notification handler code here

  UpdateData(true);

  if(this->m_hFile != NULL)
      CloseHandle(m_hFile);
  
  char COM_string[32];
  DCB dcb;	

	sprintf(COM_string,"\\\\.\\COM%d", this->m_port);
	m_hFile = CreateFile(COM_string, GENERIC_READ|GENERIC_WRITE, 0, NULL,						
	    OPEN_EXISTING, 0,NULL);

	if(m_hFile != INVALID_HANDLE_VALUE)
	{		
    GetCommState(m_hFile, &dcb);

		dcb.BaudRate  = CBR_9600;  
		dcb.ByteSize  = 8;             
		dcb.Parity    = NOPARITY;        
		dcb.StopBits  = ONESTOPBIT;    

		COMMTIMEOUTS CommTimeOuts;
		CommTimeOuts.ReadIntervalTimeout          = MAXDWORD;
		CommTimeOuts.ReadTotalTimeoutMultiplier   = 0;
		CommTimeOuts.ReadTotalTimeoutConstant     = 0;
		CommTimeOuts.WriteTotalTimeoutMultiplier  = 0;
		CommTimeOuts.WriteTotalTimeoutConstant    = 1000;
		SetCommTimeouts(m_hFile, &CommTimeOuts);
		SetCommState(m_hFile, &dcb);
	}
	else 
	{
		MessageBox("Can`t Open Port", "Error", MB_ICONERROR);	
		return;
	}
	
  
  //    EEPROM 
  DWORD lpdwBytesWritten;
  char buf[32];
  int len = sprintf(buf, "$KE,UD,GET\r\n"); 
  WriteFile( m_hFile, buf, len, &lpdwBytesWritten, NULL );    


  //     100 
  Sleep(100);

  DWORD dwBytesRead;
	unsigned char pBuff[128];

	ReadFile(m_hFile, &pBuff, sizeof(pBuff), &dwBytesRead, NULL);

  if( memcmp(pBuff, "#UD,NOTSET", 10) == 0 )
  {
    // EEPROM  
    MessageBox("Open OK\nNo data available", "Info", MB_ICONINFORMATION);    
  }
  else
  {  
    //  EEPROM  
    CString s1, temp;

    temp = pBuff;
    temp.Delete(0, 4);        //  '#UD,'
    int len = temp.GetLength();
    temp.Delete(len - 2, 2);  //     '\r\n'

    s1.Format("Open OK!\nLast visit: %s", temp);
    MessageBox(s1, "Info", MB_ICONINFORMATION);
  }


  //   
  time_t osBinaryTime;
  time( &osBinaryTime );
  CTime tm(osBinaryTime);

  len = sprintf(buf, "$KE,UD,SET,%d.%d.%d  %d:%d:%d\r\n", 
    tm.GetDay(), tm.GetMonth(), tm.GetYear(), tm.GetHour(), tm.GetMinute(), tm.GetSecond()); 
  WriteFile(m_hFile, buf, len, &lpdwBytesWritten, NULL);     	
}
